testproject/test_app/urls.py
"""URL config
----------

URL patterns for the test app
"""

# Disclaimer
# ----------
#
# Copyright (C) 2022 Helmholtz-Zentrum Hereon
#
# This file is part of django-e2ee-framework and is released under the
# EUPL-1.2 license.
# See LICENSE in the root of the repository for full licensing details.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the EUROPEAN UNION PUBLIC LICENCE v. 1.2 or later
# as published by the European Commission.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# EUPL-1.2 license for more details.
#
# You should have received a copy of the EUPL-1.2 license along with this
# program. If not, see https://www.eupl.eu/.
from __future__ import annotations

from django.urls import path
from testproject.test_app import views  # noqa: F401

app_name = "test_app"

urlpatterns = [
    path(
        "",
        views.HomeView.as_view(),
        name="home",
    ),
    path(
        "serviceworker.js",
        views.ServiceWorkerView.as_view(),
        name="serviceworker",
    ),
]

testproject/urls.py
# Disclaimer
# ----------
#
# Copyright (C) 2022 Helmholtz-Zentrum Hereon
#
# This file is part of django-e2ee-framework and is released under the
# EUPL-1.2 license.
# See LICENSE in the root of the repository for full licensing details.
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the EUROPEAN UNION PUBLIC LICENCE v. 1.2 or later
# as published by the European Commission.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# EUPL-1.2 license for more details.
#
# You should have received a copy of the EUPL-1.2 license along with this
# program. If not, see https://www.eupl.eu/.


from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path, re_path
from django.views.generic import RedirectView


class PatchRedirectView(RedirectView):
    """Patched redirect view to avoid issues with FORCE_SCRIPT_NAME"""

    def get_redirect_url(self, *args, **kwargs):
        ret = self.request.path[1:]
        script_name = settings.FORCE_SCRIPT_NAME[1:]
        while ret.startswith(script_name):
            ret = ret[len(script_name) :]
        return "/" + ret


urlpatterns = [
    path("", include("django.contrib.auth.urls")),
    path("", include("testproject.test_app.urls")),
    path(
        "e2ee/",
        include("django_e2ee.urls"),
    ),
    path("admin/doc/", include("django.contrib.admindocs.urls")),
    path("admin/", admin.site.urls),
]

if getattr(settings, "FORCE_SCRIPT_NAME", None):
    urlpatterns.append(
        re_path(  # type: ignore
            settings.FORCE_SCRIPT_NAME[1:] + ".*", PatchRedirectView.as_view()
        )
    )


# # This is only needed when using runserver.
if settings.DEBUG:
    urlpatterns += static(  # type: ignore
        "static/", document_root=settings.STATIC_ROOT
    )

testproject/test_app/models.py
from django.db import models  # noqa: F401

# Create your models here.

testproject/test_app/views.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views import generic

from django_e2ee.views import E2ELoginViewMixin


class HomeView(LoginRequiredMixin, E2ELoginViewMixin, generic.TemplateView):
    """A base view for the test app."""

    template_name = "test_app/home.html"


class ServiceWorkerView(generic.TemplateView):
    """A view to render the webmanifest"""

    template_name = "test_app/serviceworker.js"

    content_type = "application/javascript"

testproject/test_app/templates/test_app/home.html
<!doctype html>
{% load static %}
{% load e2ee %}

<html lang="en" class="no-js">

  <head>
    <title>django-e2ee-framework test</title>
  </head>

  <body>

    <h1>Test app for the django-e2ee-framework</h1>

    <div id="missing-serviceworker-message"></div>
    <b id="serviceworker-report"></b>

    {% if not user.master_key %}
      <form action="{{ e2ee_login_url }}" method="POST">
        {{ e2ee_login_form }}

        <input type="submit" name="submit_json_" value="I wrote down my passphrase">
      </form>

      <div id="successReport"></div>

    {% elif not request.session|has_session_key %}

      <div>Enter your E2EE password to read end-to-end-encrypted messages</div>

      <form action="{{ e2ee_login_url }}" method="POST">
        {{ e2ee_login_form }}
        <input type="submit" name="submit_json_" value="Submit">
      </form>

      <div id="sessionKeyReport"></div>

      <div>or identify through a different session.</div>

      <form action="{% url 'e2ee:sessionkey-list' %}" method="POST" onsubmit="submitFormAsJSON(event).then(updateSessionKeyVerificationReport)">
        <input type="submit" value="Submit">
      </form>

      <div id="sessionKeyVerificationReport"></div>

    {% elif request.session|e2ee_enabled %}

      <p>End-to-end encryption is enabled and you are all fine!</p>

      <p>
        If you like, you can add another E2EE password:
      </p>

      <form action="{% url 'e2ee:masterkeysecret-list' %}" method="POST">
        {% get_password_create_form %}

        <input type="submit" name="submit_json_" value="I wrote down my passphrase">
      </form>


    {% else %}

    <div>End-to-end encryption is awaiting approval through other session.</div>

    {% endif %}

    {% get_session_keys as session_keys %}

    {% if session_keys %}

    <h2>Your active sessions</h2>

    <ul>
      {% for session_key in session_keys %}
        <li>
          {{ session_key }}
          {% if not session_key.secret %}
          <form action="{{ session_key.get_absolute_url }}">
            {% get_session_key_form session_key %}
            <input type="submit" name="submit_json_" value="Submit">
          </form>
          <div id="sessionkey-report-{{ session_key.pk }}"></div>
          {% endif %}
        </li>
      {% endfor %}
    </ul>

    {% endif %}

    <footer>
      <script src="https://cdn.jsdelivr.net/npm/idb-keyval@6/dist/umd.js"></script>
      <script src='{% static "js/e2ee/utils.js" %}'></script>
      <script>
        {% comment %}  register service worker {% endcomment %}
        if ('serviceWorker' in navigator) {
          navigator.serviceWorker.register('{% url "test_app:serviceworker" %}')
            .then(function () {
              let elem = document.getElementById("serviceworker-report");
              // for some reasons, firefox does need a bit more time...
              setTimeout(
                function() { elem.innerHTML = "Serviceworker registered"},
                500
              );
            });
        } else {
          window.addEventListener('load', function() {
            let elem = document.getElementById("missing-serviceworker-message")
            elem.innerHTML = "<b>Serviceworkers are not available in this browser. E2EE will not work!</b>"
          });
        }
      </script>

      {% if session_keys %}
        {% get_session_key_form session_keys.first as session_key_form %}
        {{ session_key_form.media.js }}
      {% endif %}

      {{ e2ee_login_form.media.js }}

      {% if request.session|e2ee_enabled %}
        {% get_password_create_form as password_create_form %}
        {{ password_create_form.media.js }}
      {% endif %}

      <script>
        async function updateSessionKeyVerificationReport(response) {
          let body = await response.json()
          document.getElementById('sessionKeyVerificationReport').innerHTML = `
              <p>On your other device, please enter the following number:</p>
              <h3>${body.verificationNumber}</h3>
          `
        }
      </script>
    </footer>
  </body>

</html>